package com.kouponmedia.androidsample;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ScrollView;
import android.widget.TextView;

import com.google.android.gcm.GCMRegistrar;
import com.kouponmedia.kouponsdk.KMRequest;
import com.kouponmedia.kouponsdk.KMRequest.AsyncTaskListener;
import com.kouponmedia.kouponsdk.Koupon;
import com.kouponmedia.kouponsdk.Geofence.GimbalManager;
import com.kouponmedia.kouponsdk.Geofence.GimbalManagerListener;
import com.kouponmedia.kouponsdk.Geofence.KMGeofenceEvent;

public class MainActivity extends Activity implements AsyncTaskListener {

	// default values for testing
	private static final String TAG = "** Koupon API Test App **";
	private JSONArray offers;
	// String api_secret = "119901E8-5E6F-46D4-BE0A-0013A8BC23FE";
	// String auth_key =
	// "63497556511547300922a7ac0b-fddf-4160-a46e-a7709171ac88";
	String consumerId = "";
	String regId = "";
	ScrollView scrollView1;
	TextView DisplayData;
	Activity mActivity;
	private Koupon koupon;
	private GimbalManagerListener gimbalManagerListener = new GimbalManagerListener() {

		@Override
		public void onGeofenceExit(KMGeofenceEvent geoEvent) {
			// CharSequence text = "You have left "
			// + geoEvent.getPlaceEvent().getName();
			// Toast toast = Toast.makeText(mActivity, text, Toast.LENGTH_LONG);
			// toast.show();
			//
			// KMRequest request = geoEvent.getRequest();
			// if (request != null)
			// request.sendRequestAsync(listener);
		}

		@Override
		public void onGeofenceEnter(KMGeofenceEvent geoEvent) {
			// CharSequence text = "You have entered "
			// + geoEvent.getPlaceEvent().getName();
			// Toast toast = Toast.makeText(mActivity, text, Toast.LENGTH_LONG);
			// toast.show();
			//
			// KMRequest request = geoEvent.getRequest();
			// if (request != null)
			// request.sendRequestAsync(listener);
		}
	};

	AsyncTaskListener listener = (AsyncTaskListener) this;

	@Override
	public void onSuccess(JSONObject result) {
		DisplayData.setText(result.toString());
		scrollView1.fullScroll(ScrollView.FOCUS_DOWN);
		Log.i(TAG, result.toString());
		try {
			if (result.has("Offers")) {
				offers = (JSONArray) result.getJSONArray("Offers");
			}
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	@Override
	public void onFailure(JSONObject result) {
		DisplayData.setText(result.toString());
		scrollView1.fullScroll(ScrollView.FOCUS_DOWN);
		Log.i(TAG, "fail: " + result.toString());
	}

	protected void onPause() {
		super.onPause();
		GCMRegistrar.unregister(this);
	}

	private void checkNotNull(Object reference, String name) {
		if (reference == null) {
			throw new NullPointerException(name);
		}
	}

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		mActivity = this;
		scrollView1 = (ScrollView) findViewById(R.id.ScrollView1);
		DisplayData = (TextView) findViewById(R.id.displayData);
		Button button1 = (Button) findViewById(R.id.button1);
		Button button2 = (Button) findViewById(R.id.button2);
		Button button3 = (Button) findViewById(R.id.button3);
		Button button4 = (Button) findViewById(R.id.button4);
		Button button5 = (Button) findViewById(R.id.button5);
		Button btnPresented = (Button) findViewById(R.id.ButtonPresented);
		Button button9 = (Button) findViewById(R.id.button9);

		// Initialize the Koupon SDK
		koupon = new Koupon(this);
		// Register The Consumer
		// We are using a separate listener for this call in order to control
		// the flow of the other calls
		JSONObject consumerData = new JSONObject();
		KMRequest km = koupon.createConsumerIdentity(consumerData, null);
		km.sendRequestAsync(new AsyncTaskListener() {

			@Override
			public void onSuccess(JSONObject result) {
				if (result.has("consumer_identity")) {
					try {
						Koupon.consumerId = consumerId = (String) result
								.get("consumer_identity");
						Log.i("consumerId", consumerId);
					} catch (JSONException e) {
						e.printStackTrace();
					}

					// Initialize the Gimbal Geofence Listeners
					GimbalManager.getInstance().addListener(
							gimbalManagerListener);
					GimbalManager.getInstance().activateGimbal(mActivity,
							koupon);
				}
			}

			@Override
			public void onFailure(JSONObject result) {
				Log.e("koupon", "Failed to create a consumer identity.");
			}
		});

		button1.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {

				KMRequest km = koupon.getConsumerData(null);
				// km.print();
				if (km != null)
					km.sendRequestAsync(listener);
			}
		});

		button2.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				KMRequest km = koupon.getConsumerOfferList(null, null);
				// km.print();
				if (km != null)
					km.sendRequestAsync(listener);
			}
		});

		button3.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {

				String offer = "0";
				if (offer != null && offers.length() > 0) {
					try {
						offer = String.valueOf(offers.getJSONObject(0).getInt(
								"offerId"));
					} catch (JSONException e) {
						e.printStackTrace();
					}
				}
				KMRequest km = koupon.getConsumerOffer(offer, null);
				// km.print();
				if (km != null)
					km.sendRequestAsync(listener);
			}
		});

		button4.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {

				String offer = "0";
				if (offers.length() > 0) {
					try {
						offer = String.valueOf(offers.getJSONObject(0).getInt(
								"offerId"));
					} catch (JSONException e) {
						e.printStackTrace();
					}
				}
				KMRequest km = koupon.updateConsumerState("View", offer, null);
				// km.print();
				if (km != null)
					km.sendRequestAsync(listener);
			}
		});
		btnPresented.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {

				String offer = "0";
				if (offers != null && offers.length() > 0) {
					try {
						offer = String.valueOf(offers.getJSONObject(0).getInt(
								"offerId"));
					} catch (JSONException e) {
						e.printStackTrace();
					}
				}
				KMRequest km = koupon.updateConsumerState("PRESENTED", offer,
						null);
				// km.print();
				if (km != null)
					km.sendRequestAsync(listener);
			}
		});

		button5.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {

				// TODO: Add an actual Offer here.
				KMRequest km = koupon.addOfferToConsumer("0", null);
				// km.print();
				if (km != null)
					km.sendRequestAsync(listener);
			}
		});

		button9.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {

				JSONArray offerList = new JSONArray();
				// TODO: Add actual Triggered Offers
				offerList.put("0");
				offerList.put("1");

				KMRequest km = koupon.addMultipleOffersToConsumer(offerList,
						null);
				// km.print();
				if (km != null)
					km.sendRequestAsync(listener);
			}
		});
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}

}
